MinGW成的exe依赖libgcc_s_dw2-1.dll和libstdc++-6.dll,解决方案

MinGW升级到4.5.2生成的exe需要libgcc_s_dw2-1.dll和libstdc++-6.dll ?

原来生成的程序,只要带上mingwm10.dll就好,现在突然多了这两个。

原来gcc 4.5改用动态链接方式链接libgcc和libstdc,因此生成的exe就比以前多了些dll才能正常运行。

如果还是想只要有个mingwm10.dll就好怎么办呢?有办法:

根据 gcc 的手册使用下面三个参数可以处理这个问题:

-static-libgcc在 gcc/g++ 或 ld 中加上这个参数, 就可以不用 libgcc_s_dw2-1.dll

-static-libstdc++在 g++ 或 ld 中加上这个参数, 就可以不用 libstdc++-6.dll

-static在 gcc/g++ 或 ld 中加上这个参数, ?所有的库都会采用静态链接的方式

GCC 4.5 预设所有的标准程式库都是动态连结,包含C和C++,如果未加上连结选项 -static-libgcc 和 -static-libstdc++,那?编译出来的程式就需要依赖这两个 dll,无法在缺乏此 dll 的电脑上执行。即使确定采用预设的动态连结,也需要额外补上-Wl,–enable-auto-import ,否则连结出来的执行档不正确。无论如何,旧有的 makefile 都要重新调整。若不喜欢这些,记得我之前用的版本,忘掉是4.2还4.3,没有这方面的问题。

如果你使用Qt进行开发,那么有可能加了-static参数还是需要libgcc_s_dw2-1.dll和libstdc++-6.dll ,这是因为Qt的dll需要。。。。

发表评论